
TYPO3.Flow - Feature # 27698

Status: Resolved Priority: Should have
Author: Johannes K Category: Security
Created: 2011-06-26 Assigned To: Rens Admiraal
Updated: 2013-08-14 Due date:
PHP Version:
Has patch: No
Complexity:
Subject: Roles should use an adequate data type to get persisted as entities 
Description

At the moment the roles of an account get saved as a php-serialized array inside "flow3_security_account", e.g.: 

a:2:{i:0;s:12:"Adminstrator";i:1;s:4:"User";}

This is due to (in Packages/Framework/FLOW3/Classes/Security/Policy/Role.php)

/**
 * @var array
 */
protected $roles = array();

this should be something like this (untested, just to transport the idea, I have no idea of Doctrine)

/**
 * @var \Doctrine\Common\Collections\ArrayCollection<\F3\FLOW3\Security\Policy\Role>
 * @ManyToMany
 */
protected $roles = array();

so that they will get persisted as the already prepared entities \F3\FLOW3\Security\Policy\Role.

Related issues:
related to TYPO3.Flow - Bug # 28862: Inconsistent handling of roles as object... Resolved 2011-08-09

Associated revisions
Revision f0776fb3 - 2013-04-10 17:25 - Karsten Dambekalns

[!!!][FEATURE] Handle roles consistently as objects

With this change roles are consistently used as objects.

To prevent naming conflicts between roles from different packages the
package key is added to the role names.
The handling of roles now is more strict and does not allow the use of
not configured (non-existent) roles anymore.

Roles are now referenced as real instances instead of their string
identifiers in models. Roles which were defined in policies are now
automatically mirrored to the RoleRepository (usually stored as a
table in a database).

The getRoles() method has been removed from TokenInterface.

Change-Id: I39f335baa01fbe9b883e98e85cb1f063bbaf5744
Resolves: #28862
Resolves: #43578
Related: #37451
Related: #27698
Releases: 2.0, master

Revision 28e52aa8 - 2013-04-11 12:27 - Karsten Dambekalns

[!!!][FEATURE] Handle roles consistently as objects

With this change roles are consistently used as objects.

To prevent naming conflicts between roles from different packages the
package key is added to the role names.

The handling of roles now is more strict and does not allow the use of
not configured (non-existent) roles anymore.

Roles are now referenced as real instances instead of their string
identifiers in models. Roles which were defined in policies are now
automatically mirrored to the RoleRepository (usually stored as a
table in a database).

The getRoles() method has been removed from TokenInterface.

Change-Id: I39f335baa01fbe9b883e98e85cb1f063bbaf5744
Resolves: #28862
Resolves: #43578
Related: #37451
Related: #27698
Releases: 2.0, master

History
#1 - 2011-08-09 11:41 - Christopher Hlubek

This is due to inconsistent handling of Roles as strings or objects inside TYPO3\FLOW3\Security\Account. And the roles mapping would have to
change, too.

#2 - 2012-08-19 22:56 - Rens Admiraal

2015-08-03 2/3



- Assigned To set to Rens Admiraal
- Has patch set to No

#3 - 2012-12-04 12:28 - Karsten Dambekalns
- Status changed from New to Under Review
- Target version set to 2.0 beta 1

#4 - 2012-12-09 21:25 - Karsten Dambekalns
- Target version changed from 2.0 beta 1 to 2.1

#5 - 2013-05-21 13:28 - Robert Lemke
- Target version deleted (2.1)

#6 - 2013-08-14 16:00 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- Target version set to 2.0
- % Done changed from 0 to 100
